#include <iostream>
//#include <fstream>
//#include <iomanip>
#include <cmath>
//#include <algorithm>
//#include <string>
#include <vector>
#include <utility>
//#include <map>
//#include <ctime>
//#include <cctype>
//#include <cstdlib>
//#include <limits>
//#include <numeric>
//#include <mycpp.h>

using namespace std;

typedef long long ll;
struct Point {
	ll x, y;
};

const ll mod = 1000000007;

ll CalculateStep(Point a, Point b) {
	return (((ll)abs(a.x - b.x) % mod) * ((ll)abs(a.y - b.y) % mod)) % mod;
}

int main()
{
	std::ios_base::sync_with_stdio(false);
	ll n;
	cin >> n;
	ll scores[n];
	ll res[n];
	vector<Point> points;
	
	for(int i = 0; i < n; i++) {
		Point p;
		cin >> p.x >> p.y;
		points.push_back(p);
		scores[i] = 0;
		int max = 0;
		for(int j = 0; j < i; j++) {
			ll nov = CalculateStep(points[j], p);
			scores[j] = (scores[j] + nov) % mod;
			if(scores[j] > max) max = scores[j];
			scores[i] = (scores[i] + nov) % mod;
		}
		if(scores[i] > max) max = scores[i];
		res[i] = max;
	}
	
	
	//ispis
	for(int i = 0; i < n; i++) 
		cout << res[i] << endl;
}